/*
   Sirius IRC Services 2
   Copyright (c) 2000, Sirius IRC Services Team
   All rights reserved.

   Redistribution and use in source and binary forms, with or without modification, are permitted
   provided that the following conditions are met:
   
     * Redistributions of source code must retain the above copyright notice, this list of conditions
       and the following disclaimer.
     * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
       and the following disclaimer in the documentation and/or other materials provided with the
       distribution.
     * Neither the name of the Sirius IRC Services Team nor the names of its contributors may be used
       to endorse or promote products derived from this software without specific prior written permission.
     * The source code may not be redistributed for a fee or in closed source
       programs, without approval from the Sirius IRC Services Team, however
       for operating systems where binary distribution is required, if URL
       is passed with the package to get the full source
     * No warranty is given unless stated so by the Sirius IRC Services Team

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS `AS IS'' AND ANY EXPRESS OR
   IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
   FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
   BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR  
   BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <new>
#include <stdio.h>
#include <sys/types.h>
#include <errno.h>
#include <signal.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdarg.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/file.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <ctype.h>
#include <time.h>
#include <sys/resource.h>

/* Configuration */
#include "config.h"
#include "options.h"
#include "conf.h"
#include "malloc.h"

inline void *operator new(size_t siz)
{ 
   return smalloc(siz);
}

inline void operator delete(void *p)
{
   if (p)
	   sfree(p);
}

inline void *operator new[](size_t siz)
{
   return operator new(siz);
}

inline void operator delete[](void *p, size_t siz)
{
   if (p)
      operator delete(p);
}

/* inline void *operator new(size_t, void *p)
{
	return p;
}*/
               

/* Classes */
#include "diskio.h"
#include "timer.h"
#include "signals.h"
#include "socket.h"
#include "hash.h"
#include "link.h"
#include "channel.h"
#include "parse.h"
#include "server.h"
#include "reg.h"
#include "user.h"
#include "help.h"
#include "chanserv.h"
#include "nickserv.h"
#include "operserv.h"
#include "find.h"
#include "log.h"
#include "msgtab.h"
#include "language.h"
#include "mail.h"

/* Misc includes */

#include "version.h"
#include "struct.h"
#include "defs.h"
#include "struct.h"
#include "protocol.h"
#include "extern.h"
#include "replies.h"
