/*
   Sirius IRC Services 2
   Copyright (c) 2000, Sirius IRC Services Team
   All rights reserved.

   Redistribution and use in source and binary forms, with or without modification, are permitted
   provided that the following conditions are met:
   
     * Redistributions of source code must retain the above copyright notice, this list of conditions
       and the following disclaimer.
     * Redistributions in binary form must reproduce the above copyright notice, this list of conditions
       and the following disclaimer in the documentation and/or other materials provided with the
       distribution.
     * Neither the name of the Sirius IRC Services Team nor the names of its contributors may be used
       to endorse or promote products derived from this software without specific prior written permission.
     * The source code may not be redistributed for a fee or in closed source
       programs, without approval from the Sirius IRC Services Team, however
       for operating systems where binary distribution is required, if URL
       is passed with the package to get the full source
     * No warranty is given unless stated so by the Sirius IRC Services Team

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS `AS IS'' AND ANY EXPRESS OR
   IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
   FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
   BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR  
   BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "services.h"

#ifndef HAVE_STRTOKEN
char *strtoken(char **save, char *str, char *fs)
{
	char *pos = *save;	/* keep last position across calls */
	char *tmp;

	if (str)
		pos = str;	/* new string scan */

	while (pos && *pos && index(fs, *pos) != NULL)
		pos++;		/* skip leading separators */

	if (!pos || !*pos)
		return (pos = *save = NULL);	/* string contains only sep's */

	tmp = pos;		/* now, keep position of the token */

	while (*pos && index(fs, *pos) == NULL)
		pos++;		/* skip content of the token */

	if (*pos)
		*pos++ = '\0';	/* remove first sep after the token */
	else
		pos = NULL;	/* end of string */

	*save = pos;
	return (tmp);
}
#endif

char	*MergeArgs(char **args, int argc)
{
	static char buffer[1024];
	int	i;
	*buffer = '\0';

	for (i = 1; i < argc; i++)
		if (i != (argc - 1))
		{
			strcat(buffer, args[i]);
			strcat(buffer, " ");
		}
			else
		{
			strcat(buffer, args[i]);
		}
	return (buffer);
}


int check_match(char *mask) {
	if(!index(mask, '*') && !index(mask, '?'))
		return 0;
	else if(!strcmp(mask, "*"))
		return 1;
	else
		return 2;
}

int exp_match(char *string, char *mask) {
	int i=check_match(mask);
	if(!i)
	  return strcasecmp(string, mask);
	else if(i==1 && *string)
	  return 0;
	else {
		char *str = string;
		char *wld = mask;
		
		while(*str || *wld) {
			if(*wld == '*') {
				wld++;
				if(*wld) {
					str = index(str, *wld);
					if(!*str && *wld)
					  return 1;
				}
				else
				  return 0;
			}
			else if(*wld == '?') {
				str++;
				wld++;
			}
			else if(*str == *wld) {
				str++;
				wld++;
			}
			else if(!*str && !*wld)
			  return 0;
			else
			  return 1;
		}
		return 1;
	}
}		

int	match(char *str, char *wld)
{
	int i = check_match(wld);
	switch(i) {
		case 0:
			return strcasecmp(str, wld);
			break;
		case 1:
			return 0;
			break;
	}
	
	if (!(*wld) || !(*str))
		return 1;
	while (*wld || *str) {
		if (tolower(*wld) == tolower(*str)) {
			wld++;
			str++;
		} else if (tolower(*wld) != tolower(*str) && *wld == '*') {
			int		i = 0;
			char		*st;
			st = (char *) smalloc(sizeof(char[strlen(wld) + 1]));
			while (*wld == '*' && *wld) {
				wld++;
				if (!*wld)
				{
					sfree(st);
					return 0;
				}
			}
			while (*wld && *wld != '*' && *wld != '?') {
				st[i] = *wld;
				i++;
				wld++;
			}
			st[i] = '\0';
			while (*str && strncasecmp(st, str, strlen(st)))
				str++;
			if (!strncasecmp(st, str, strlen(st)))
				str += strlen(st);
			else {
				sfree(st);
				return 1;
			}
			sfree(st);
		} else if (tolower(*wld) != tolower(*str) && *wld == '?' && *wld && *str) {
			wld++;
			str++;
		} else if (tolower(*wld) != tolower(*str))
			return 1;
	}
	return 0;
}
